<?php declare(strict_types=1);

namespace Plugin\css_crossselling\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;


/*
CREATE TABLE `css_crossselling_konfig` (
  `version` float NOT NULL DEFAULT 100,
  `sqlupdate` int(10) NOT NULL DEFAULT 0,
  `maxArtikel` int(11) NOT NULL DEFAULT 0,
  `insertType` varchar(10) NOT NULL DEFAULT 'append',
  `attributesName` varchar(64) NOT NULL DEFAULT 'xSell',
  `kArtikel` int(10) NOT NULL DEFAULT 0
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_general_ci;

--
-- Daten für Tabelle `css_crossselling_konfig`
--

INSERT INTO `css_crossselling_konfig` (`version`, `sqlupdate`, `maxArtikel`, `insertType`, `attributesName`, `kArtikel`) VALUES
(102, 3, 6, 'replace', 'xSeller', 1673);
*/

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function copyTable($sourceDB, $destinationDB = "", $copyTable = true, $deleteSourceDB = false) {
		$oHasInserts = $this->getDB()->query("select * from ".$destinationDB." where 1 limit 1",2);
		if($oHasInserts !== null && $oHasInserts !== false && count($oHasInserts)>0) return;
		$result = $this->getDB()->query("SHOW TABLES LIKE '" . $sourceDB . "'", 2);
		if ($copyTable && $result !== null && count($result)) {
			$this->JTLWriteLog("Übertrage Daten von ".$sourceDB." nach ".$destinationDB,JTLLOG_LEVEL_DEBUG);
			$aField = $this->getDB()->query("Show columns from ".$destinationDB." like '%'",2);
			$result = $this->getDB()->query("SELECT * FROM " . $sourceDB . " WHERE 1", 2);
			foreach ($result as $oItem) {
				$obj = new \stdClass();
				foreach($aField as $oField) {
					if(isset($oItem->{$oField->Field})) {
						$obj->{$oField->Field} = $oItem->{$oField->Field};
					}
				}
				$this->getDB()->insert($destinationDB, $obj);
			}
		}
		if ($deleteSourceDB) {
			$this->execute("DROP TABLE IF EXISTS " . $sourceDB, 3);
		}
	}


	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function JTLWriteLog($cLog = '', $nLevel = JTLLOG_LEVEL_INFO, $bForce = false) {
		if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
			$logger = Shop::Container()->getLogService();
			$logger = $logger->withName("css_crossselling");
			$logger->log($nLevel, $cLog, ["css_crossselling"]);
			return true;
		}
		return false;
	}




	public function up() {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_crosssellingConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '1.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `hideArtikel` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `selector` varchar(255) NOT NULL DEFAULT '#content',
                  `selector_position` varchar(255) NOT NULL DEFAULT 'prepend',
								  `maxArtikel` int(11) NOT NULL DEFAULT 6,
								  `insertType` varchar(10) NOT NULL DEFAULT 'append',
								  `attributesName` varchar(64) NOT NULL DEFAULT 'xSell',
								  `kArtikel` int(10) NOT NULL DEFAULT 0,
								  `cArtNr` varchar(50) NOT NULL DEFAULT ''
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->copyTable("css_crossselling_konfig", "css_crosssellingConfig", true, false);



		$result = $this->getDB()->query(
			'SELECT * from `css_crosssellingConfig` where 1',
			2
		);

		if ($result === null || count($result) < 1) {
			$this->execute(
				"INSERT INTO `css_crosssellingConfig` (`version`) VALUES ('1.0.0')"
			);
		} else {
			$this->execute("UPDATE css_crosssellingConfig set `version` = '1.0.0' ");
		}
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
